package com.ruoyi.platform.mapper;

import com.ruoyi.platform.domain.ImageVersion;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;
import java.util.List;

/**
 * (ImageVersion)表数据库访问层
 *
 * @author Xidaray
 * @since 2024-03-05 15:00:02
 */
public interface ImageVersionDao {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    ImageVersion queryById(Integer id);

    /**
     * 查询指定行数据
     *
     * @param imageVersion 查询条件
     * @param pageable         分页对象
     * @return 对象列表
     */
    List<ImageVersion> queryAllByLimit(@Param("imageVersion") ImageVersion imageVersion, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param imageVersion 查询条件
     * @return 总行数
     */
    long count(@Param("imageVersion") ImageVersion imageVersion);

    /**
     * 新增数据
     *
     * @param imageVersion 实例对象
     * @return 影响行数
     */
    int insert(@Param("imageVersion") ImageVersion imageVersion);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<ImageVersion> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<ImageVersion> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<ImageVersion> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<ImageVersion> entities);

    /**
     * 修改数据
     *
     * @param imageVersion 实例对象
     * @return 影响行数
     */
    int update(@Param("imageVersion") ImageVersion imageVersion);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    List<ImageVersion> queryByImageId(Integer imageId);

    ImageVersion queryByUrl(String url);
}

